using UnityEngine;
using UnityEngine.UI;
using TMPro;
using BackEnd;

public class FindID : LoginBase
{
	[SerializeField]
	private	Image				imageEmail;			// E-mail ʵ  
	[SerializeField]
	private	TMP_InputField		inputFieldEmail;	// E-mail ʵ ؽƮ  

	[SerializeField]
	private	Button				btnFindID;			// "̵ ã" ư (ȣۿ /Ұ)

	public void OnClickFindID()
	{
		// Ű Է InputField UI  Message  ʱȭ
		ResetUI(imageEmail);

		// ʵ  ִ üũ
		if ( IsFieldDataEmpty(imageEmail, inputFieldEmail.text, " ּ") )	return;

		//   ˻
		if ( !inputFieldEmail.text.Contains("@") )
		{
			GuideForIncorrectlyEnteredData(imageEmail, "  ߸Ǿϴ.(ex. address@xx.xx)");
			return;
		}

		// "̵ ã" ư ȣۿ Ȱȭ
		btnFindID.interactable = false;
		SetMessage(" ߼Դϴ..");

		// ڳ  ̵ ã õ
		FindCustomID();
	}

	private void FindCustomID()
	{
		// ̵  ̸Ϸ ߼
		Backend.BMember.FindCustomID(inputFieldEmail.text, callback =>
		{
			// "̵ ã" ư ȣۿ Ȱȭ
			btnFindID.interactable = true;

			//  ߼ 
			if ( callback.IsSuccess() )
			{
				SetMessage($"{inputFieldEmail.text} ּҷ  ߼Ͽϴ.");
			}
			//  ߼ 
			else
			{
				string message = string.Empty;

				switch ( int.Parse(callback.GetStatusCode()) )
				{
					case 404:	// ش ̸ ̸Ӱ  
						message = "ش ̸ ϴ ڰ ϴ.";
						break;
					case 429:	// 24ð ̳ 5ȸ ̻  ̸  ̵/йȣ ã⸦ õ 
						message = "24ð ̳ 5ȸ ̻ ̵/йȣ ã⸦ õ߽ϴ.";
						break;
					default:
						// statusCode : 400 => Ʈ Ưڰ ߰  (ȳ  ̹߼   ߻)
						message = callback.GetMessage();
						break;
				}

				if ( message.Contains("̸") )
				{
					GuideForIncorrectlyEnteredData(imageEmail, message);
				}
				else
				{
					SetMessage(message);
				}
			}
		});
	}
}

